/* 
 * PVM++ - A C++ library for easy use of PVM
 * Copyright (C) 1997-2001 Sebastian Wilhelmi; University of Karlsruhe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pvm++/private.hh"

namespace Pvm
{
  using namespace Internal;

  Host::operator unsigned int () const
  {
    return Where->Id;
  }

  std::string
  Host::Name () const
  {
    return Where->Name;
  }

  std::string 
  Host::Arch () const
  {
    return Where->Arch;
  }

  unsigned int
  Host::Speed () const
  {
    return Where->Speed;
  }

  bool Host::Running () const
  {
    return Where->Running;
  }

  void
  Host::Tasks (TaskSet &Result) const
  {  
    Pvm (); // Make sure the PVM is started.

    GetTasks (Where->Id, Result);
  }

  HostEntry *
  Host::Get (unsigned int Id)
  {  
    Pvm (); // Make sure the PVM is started.

    return HostTable->Get (Id);
  }
  
} // namespace Pvm
