/* 
 * PVM++ - A C++ library for easy use of PVM
 * Copyright (C) 1997-2001 Sebastian Wilhelmi; University of Karlsruhe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PVM_PRIVATETYPES_HH__
#define __PVM_PRIVATETYPES_HH__

#include <pvm++/types.hh>

#include <list>

namespace Pvm
{

  static const unsigned int HostDeleteInfo = 1;
  static const unsigned int HostAddInfo = 2;
  static const unsigned int StructIdOffset = 10;
  
  class HandlerTableType;
  class HostTableType;
  class Internal;
  class Received;
  class TaskTableType;
  
  typedef std::list< Received > QueueType;
  typedef QueueType::iterator QueueIterator;
  typedef std::pair< ReceiveAction, Struct * > HandlerTableEntry;

} // namespace Pvm

#endif /* __PVM_PRIVATETYPES_HH__ */
