/* 
 * PVM++ - A C++ library for easy use of PVM
 * Copyright (C) 1997-2001 Sebastian Wilhelmi; University of Karlsruhe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PVM_TASKTABLETYPE_HH__
#define __PVM_TASKTABLETYPE_HH__

#include <pvm++/taskentry.hh>

#include <map>
#include <stdio.h>
#include <pvm3.h>

namespace Pvm
{

  class TaskTableType : public std::map< unsigned int, TaskEntry >
  {
  public:
    TaskTableType ();
    iterator Add (unsigned int Id, const pvmtaskinfo *What, bool IsZero);
    iterator Refresh (unsigned int Id);
    TaskEntry *Get (unsigned int Id);
  private:
    TaskEntry ZeroEntry;
  };

} // namespace Pvm

#endif /* __PVM_TASKTABLETYPE_HH__ */
